<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.xml.config;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.util.Iterator;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.util.List;<a name="line.37"></a>
<FONT color="green">038</FONT>    <a name="line.38"></a>
<FONT color="green">039</FONT>    import org.dom4j.Attribute;<a name="line.39"></a>
<FONT color="green">040</FONT>    import org.dom4j.Element;<a name="line.40"></a>
<FONT color="green">041</FONT>    import org.dom4j.Node;<a name="line.41"></a>
<FONT color="green">042</FONT>    <a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.xml.config.XmlConfig.XmlAttribute;<a name="line.43"></a>
<FONT color="green">044</FONT>    <a name="line.44"></a>
<FONT color="green">045</FONT>    public class XmlUtil {<a name="line.45"></a>
<FONT color="green">046</FONT>            <a name="line.46"></a>
<FONT color="green">047</FONT>            /**<a name="line.47"></a>
<FONT color="green">048</FONT>             * Returns the child element of the given type which has the desired <a name="line.48"></a>
<FONT color="green">049</FONT>             * attribute value in the given attribute. In xpath, this would be somewhat<a name="line.49"></a>
<FONT color="green">050</FONT>             * like &lt;code&gt;/child[@attribute=$attributeValue]&lt;/code&gt;<a name="line.50"></a>
<FONT color="green">051</FONT>             * &lt;p&gt;<a name="line.51"></a>
<FONT color="green">052</FONT>             * If multiple children match the criteria, an exception is thrown. If no<a name="line.52"></a>
<FONT color="green">053</FONT>             * child matching the criteria is found, then either &lt;code&gt;null&lt;/code&gt; is<a name="line.53"></a>
<FONT color="green">054</FONT>             * returned (if &lt;code&gt;throwExceptionIfNull==false&lt;/code&gt;), or an exception<a name="line.54"></a>
<FONT color="green">055</FONT>             * is thrown (otherwise).<a name="line.55"></a>
<FONT color="green">056</FONT>             * <a name="line.56"></a>
<FONT color="green">057</FONT>             * @param element                               the parent element containing the desired <a name="line.57"></a>
<FONT color="green">058</FONT>             *                                                              child element<a name="line.58"></a>
<FONT color="green">059</FONT>             * @param child                                 specifies the name of the child element<a name="line.59"></a>
<FONT color="green">060</FONT>             * @param attribute                             specifies the name of the identifying attribute<a name="line.60"></a>
<FONT color="green">061</FONT>             * @param attributeValue                the desired attribute value<a name="line.61"></a>
<FONT color="green">062</FONT>             * @param throwExceptionIfNull  if &lt;code&gt;true&lt;/code&gt;, an exception is thrown <a name="line.62"></a>
<FONT color="green">063</FONT>             *                                                              if no child matches the criteria<a name="line.63"></a>
<FONT color="green">064</FONT>             * @return                                              the desired child element, or <a name="line.64"></a>
<FONT color="green">065</FONT>             *                                                              &lt;code&gt;null&lt;/code&gt; if <a name="line.65"></a>
<FONT color="green">066</FONT>             *                                                              &lt;code&gt;throwExceptionIfNull==false&lt;/code&gt; and<a name="line.66"></a>
<FONT color="green">067</FONT>             *                                                              no child element matched the criteria<a name="line.67"></a>
<FONT color="green">068</FONT>             * @throws XmlConfigException   If multiple matches occur, or if no match<a name="line.68"></a>
<FONT color="green">069</FONT>             *                                                              was found and exception throwing is desired<a name="line.69"></a>
<FONT color="green">070</FONT>             *                                                              for this case (see &lt;code&gt;throwExceptionIfNull&lt;/code&gt;)<a name="line.70"></a>
<FONT color="green">071</FONT>             */<a name="line.71"></a>
<FONT color="green">072</FONT>            @SuppressWarnings("unchecked")<a name="line.72"></a>
<FONT color="green">073</FONT>            public static Element getChildElementByAttributeValue(Element element, XmlNode child, XmlNode attribute, String attributeValue, boolean throwExceptionIfNull) throws XmlConfigException {<a name="line.73"></a>
<FONT color="green">074</FONT>                    Element res = null;<a name="line.74"></a>
<FONT color="green">075</FONT>                    Iterator&lt;Element&gt; it = element.elementIterator(child.getXmlName());<a name="line.75"></a>
<FONT color="green">076</FONT>                    while (it.hasNext()) {<a name="line.76"></a>
<FONT color="green">077</FONT>                            Element el = it.next();<a name="line.77"></a>
<FONT color="green">078</FONT>                            String attValue = el.attributeValue(attribute.getXmlName());<a name="line.78"></a>
<FONT color="green">079</FONT>                            if (attributeValue.equals(attValue)) {<a name="line.79"></a>
<FONT color="green">080</FONT>                                    if (res == null) res = el;<a name="line.80"></a>
<FONT color="green">081</FONT>                                    else {<a name="line.81"></a>
<FONT color="green">082</FONT>                                            throw new XmlConfigException(<a name="line.82"></a>
<FONT color="green">083</FONT>                                                    "multiple matches for " + child.getXmlName() + " children with attribute " + <a name="line.83"></a>
<FONT color="green">084</FONT>                                                    attribute.getXmlName() + "='" + attributeValue + "'", element<a name="line.84"></a>
<FONT color="green">085</FONT>                                            );<a name="line.85"></a>
<FONT color="green">086</FONT>                                    }<a name="line.86"></a>
<FONT color="green">087</FONT>                            }<a name="line.87"></a>
<FONT color="green">088</FONT>                    }<a name="line.88"></a>
<FONT color="green">089</FONT>                    if (res == null &amp;&amp; throwExceptionIfNull) {<a name="line.89"></a>
<FONT color="green">090</FONT>                            throw new XmlConfigException(<a name="line.90"></a>
<FONT color="green">091</FONT>                                    "missing " + child.getXmlName() + " child with attribute " + <a name="line.91"></a>
<FONT color="green">092</FONT>                                    attribute.getXmlName() + "='" + attributeValue + "'", element<a name="line.92"></a>
<FONT color="green">093</FONT>                            );<a name="line.93"></a>
<FONT color="green">094</FONT>                    }<a name="line.94"></a>
<FONT color="green">095</FONT>                    return res;<a name="line.95"></a>
<FONT color="green">096</FONT>            }<a name="line.96"></a>
<FONT color="green">097</FONT>            <a name="line.97"></a>
<FONT color="green">098</FONT>            /**<a name="line.98"></a>
<FONT color="green">099</FONT>             * Returns a typed iterator for child elements of a certain type<a name="line.99"></a>
<FONT color="green">100</FONT>             * <a name="line.100"></a>
<FONT color="green">101</FONT>             * @param element       parent of which certain child elements are desired<a name="line.101"></a>
<FONT color="green">102</FONT>             * @param childType node defining the name of the desired child elements<a name="line.102"></a>
<FONT color="green">103</FONT>             */<a name="line.103"></a>
<FONT color="green">104</FONT>            @SuppressWarnings("unchecked")<a name="line.104"></a>
<FONT color="green">105</FONT>            public static Iterator&lt;Element&gt; getChildElements(Element element, XmlNode childType) throws XmlConfigException {<a name="line.105"></a>
<FONT color="green">106</FONT>                    return element.elementIterator(childType.getXmlName());         <a name="line.106"></a>
<FONT color="green">107</FONT>            }<a name="line.107"></a>
<FONT color="green">108</FONT>            <a name="line.108"></a>
<FONT color="green">109</FONT>            /**<a name="line.109"></a>
<FONT color="green">110</FONT>             * Returns the desired single child element, or throws an exception if none<a name="line.110"></a>
<FONT color="green">111</FONT>             * or multiple are found.<a name="line.111"></a>
<FONT color="green">112</FONT>             * <a name="line.112"></a>
<FONT color="green">113</FONT>             * @param element                               the parent of the desired child<a name="line.113"></a>
<FONT color="green">114</FONT>             * @param child                                 specifies the desired child element name<a name="line.114"></a>
<FONT color="green">115</FONT>             * @return                                              the child element<a name="line.115"></a>
<FONT color="green">116</FONT>             * @throws XmlConfigException   if no or multiple children match the <a name="line.116"></a>
<FONT color="green">117</FONT>             *                                                              criteria<a name="line.117"></a>
<FONT color="green">118</FONT>             */<a name="line.118"></a>
<FONT color="green">119</FONT>            public static Element getRequiredSingleChildElement(Element element, XmlNode child) throws XmlConfigException {<a name="line.119"></a>
<FONT color="green">120</FONT>                    final Element result = getOptionalSingleChildElement(element, child);<a name="line.120"></a>
<FONT color="green">121</FONT>                    if (result == null) {<a name="line.121"></a>
<FONT color="green">122</FONT>                            throw new XmlConfigException("missing " + child.getXmlName() + " child element", element);<a name="line.122"></a>
<FONT color="green">123</FONT>                    }<a name="line.123"></a>
<FONT color="green">124</FONT>                    return result;<a name="line.124"></a>
<FONT color="green">125</FONT>            }<a name="line.125"></a>
<FONT color="green">126</FONT>            /**<a name="line.126"></a>
<FONT color="green">127</FONT>             * Returns the desired single child element, or throws an exception if none<a name="line.127"></a>
<FONT color="green">128</FONT>             * or multiple are found.<a name="line.128"></a>
<FONT color="green">129</FONT>             * <a name="line.129"></a>
<FONT color="green">130</FONT>             * @param element                               the parent of the desired child<a name="line.130"></a>
<FONT color="green">131</FONT>             * @param child                                 specifies the desired child element name<a name="line.131"></a>
<FONT color="green">132</FONT>             * @return                                              the child element<a name="line.132"></a>
<FONT color="green">133</FONT>             * @throws XmlConfigException   if no or multiple children match the <a name="line.133"></a>
<FONT color="green">134</FONT>             *                                                              criteria<a name="line.134"></a>
<FONT color="green">135</FONT>             */<a name="line.135"></a>
<FONT color="green">136</FONT>            public static Element getOptionalSingleChildElement(Element element, XmlNode child) throws XmlConfigException {<a name="line.136"></a>
<FONT color="green">137</FONT>                    @SuppressWarnings("unchecked")<a name="line.137"></a>
<FONT color="green">138</FONT>                    List&lt;Element&gt; list = element.elements(child.getXmlName());<a name="line.138"></a>
<FONT color="green">139</FONT>                    if (list.isEmpty()) {<a name="line.139"></a>
<FONT color="green">140</FONT>                            return null;<a name="line.140"></a>
<FONT color="green">141</FONT>                    }<a name="line.141"></a>
<FONT color="green">142</FONT>                    else if (list.size() &gt; 1) {<a name="line.142"></a>
<FONT color="green">143</FONT>                            throw new XmlConfigException("expected single " + child.getXmlName() + " child, but found " + list.size(), element);<a name="line.143"></a>
<FONT color="green">144</FONT>                    }<a name="line.144"></a>
<FONT color="green">145</FONT>                    return list.get(0);<a name="line.145"></a>
<FONT color="green">146</FONT>            }<a name="line.146"></a>
<FONT color="green">147</FONT>    <a name="line.147"></a>
<FONT color="green">148</FONT>            /**<a name="line.148"></a>
<FONT color="green">149</FONT>             * Returns the desired attribute value, or throws an exception no such<a name="line.149"></a>
<FONT color="green">150</FONT>             * attribute exists.<a name="line.150"></a>
<FONT color="green">151</FONT>             * <a name="line.151"></a>
<FONT color="green">152</FONT>             * @param element                               the element to get the attribute value from<a name="line.152"></a>
<FONT color="green">153</FONT>             * @param attribute                             specifies the desired attribute name<a name="line.153"></a>
<FONT color="green">154</FONT>             * @return                                              the attribute value<a name="line.154"></a>
<FONT color="green">155</FONT>             * @throws XmlConfigException   if no such attribute value is defined<a name="line.155"></a>
<FONT color="green">156</FONT>             */<a name="line.156"></a>
<FONT color="green">157</FONT>            public static String getRequiredAttributeValue(Element element, XmlNode attribute) throws XmlConfigException {<a name="line.157"></a>
<FONT color="green">158</FONT>                    Attribute att = element.attribute(attribute.getXmlName());<a name="line.158"></a>
<FONT color="green">159</FONT>                    if (att == null) {<a name="line.159"></a>
<FONT color="green">160</FONT>                            throw new XmlConfigException("missing " + attribute.getXmlName() + " attribute for " + element.getName() + " element", element);<a name="line.160"></a>
<FONT color="green">161</FONT>                    }<a name="line.161"></a>
<FONT color="green">162</FONT>                    return att.getValue();<a name="line.162"></a>
<FONT color="green">163</FONT>            }<a name="line.163"></a>
<FONT color="green">164</FONT>            /**<a name="line.164"></a>
<FONT color="green">165</FONT>             * Returns the desired attribute value, or the given default value if no <a name="line.165"></a>
<FONT color="green">166</FONT>             * such attribute exists.<a name="line.166"></a>
<FONT color="green">167</FONT>             * <a name="line.167"></a>
<FONT color="green">168</FONT>             * @param element                               the element to get the attribute value from<a name="line.168"></a>
<FONT color="green">169</FONT>             * @param attribute                             specifies the desired attribute name<a name="line.169"></a>
<FONT color="green">170</FONT>             * @param defaultValue                  the default value to use if no such <a name="line.170"></a>
<FONT color="green">171</FONT>             *                                                              attribute exists<a name="line.171"></a>
<FONT color="green">172</FONT>             * @return                                              the attribute value, or the default if no<a name="line.172"></a>
<FONT color="green">173</FONT>             *                                                              such attribute exists<a name="line.173"></a>
<FONT color="green">174</FONT>             */<a name="line.174"></a>
<FONT color="green">175</FONT>            public static String getOptionalAttributeValue(Element element, XmlNode attribute, String defaultValue) throws XmlConfigException {<a name="line.175"></a>
<FONT color="green">176</FONT>                    Attribute att = element.attribute(attribute.getXmlName());<a name="line.176"></a>
<FONT color="green">177</FONT>                    if (att == null) {<a name="line.177"></a>
<FONT color="green">178</FONT>                            return defaultValue;<a name="line.178"></a>
<FONT color="green">179</FONT>                    }<a name="line.179"></a>
<FONT color="green">180</FONT>                    return att.getValue();<a name="line.180"></a>
<FONT color="green">181</FONT>            }<a name="line.181"></a>
<FONT color="green">182</FONT>            <a name="line.182"></a>
<FONT color="green">183</FONT>            /**<a name="line.183"></a>
<FONT color="green">184</FONT>             * Check whether the given element has the desired name. Throws an exception<a name="line.184"></a>
<FONT color="green">185</FONT>             * otherwise.<a name="line.185"></a>
<FONT color="green">186</FONT>             * <a name="line.186"></a>
<FONT color="green">187</FONT>             * @param element                               the element to check<a name="line.187"></a>
<FONT color="green">188</FONT>             * @param expected                              specifies the expected element name<a name="line.188"></a>
<FONT color="green">189</FONT>             * @throws XmlConfigException   if the check fails<a name="line.189"></a>
<FONT color="green">190</FONT>             */<a name="line.190"></a>
<FONT color="green">191</FONT>            public static void checkExpectedElementName(Element element, XmlNode expected) throws XmlConfigException {<a name="line.191"></a>
<FONT color="green">192</FONT>                    if (!isExpectedElementName(element, expected)) {<a name="line.192"></a>
<FONT color="green">193</FONT>                            throw new XmlConfigException(expected.getXmlName() + " element expected, but " + element.getName() + " found", element);<a name="line.193"></a>
<FONT color="green">194</FONT>                    }<a name="line.194"></a>
<FONT color="green">195</FONT>            }<a name="line.195"></a>
<FONT color="green">196</FONT>            /**<a name="line.196"></a>
<FONT color="green">197</FONT>             * Returns true if the given element has the desired name.<a name="line.197"></a>
<FONT color="green">198</FONT>             * <a name="line.198"></a>
<FONT color="green">199</FONT>             * @param element                               the element to check<a name="line.199"></a>
<FONT color="green">200</FONT>             * @param expected                              specifies the expected element name<a name="line.200"></a>
<FONT color="green">201</FONT>             * @return true if the check is successful<a name="line.201"></a>
<FONT color="green">202</FONT>             */<a name="line.202"></a>
<FONT color="green">203</FONT>            public static boolean isExpectedElementName(Element element, XmlNode expected) {<a name="line.203"></a>
<FONT color="green">204</FONT>                    return expected.getXmlName().equals(element.getName());<a name="line.204"></a>
<FONT color="green">205</FONT>            }<a name="line.205"></a>
<FONT color="green">206</FONT>            <a name="line.206"></a>
<FONT color="green">207</FONT>            /**<a name="line.207"></a>
<FONT color="green">208</FONT>             * Check whether the given element has the desired value for a specific<a name="line.208"></a>
<FONT color="green">209</FONT>             * attribute. Throws an exception otherwise.<a name="line.209"></a>
<FONT color="green">210</FONT>             * <a name="line.210"></a>
<FONT color="green">211</FONT>             * @param element                               the element to check<a name="line.211"></a>
<FONT color="green">212</FONT>             * @param attribute                             specifies the attribute name<a name="line.212"></a>
<FONT color="green">213</FONT>             * @param expectedValue                 the desired attribute value<a name="line.213"></a>
<FONT color="green">214</FONT>             * @throws XmlConfigException   if the check fails<a name="line.214"></a>
<FONT color="green">215</FONT>             */<a name="line.215"></a>
<FONT color="green">216</FONT>            public static void checkExpectedAttributeValue(Element element, XmlNode attribute, String expectedValue) throws XmlConfigException {<a name="line.216"></a>
<FONT color="green">217</FONT>                    String value = element.attributeValue(attribute.getXmlName());<a name="line.217"></a>
<FONT color="green">218</FONT>                    if (!expectedValue.equals(value)) {<a name="line.218"></a>
<FONT color="green">219</FONT>                            throw new XmlConfigException(<a name="line.219"></a>
<FONT color="green">220</FONT>                                    "expected value '" + expectedValue + "' for attribute '" + <a name="line.220"></a>
<FONT color="green">221</FONT>                                    attribute.getXmlName() + "', but found '" + value + "'",<a name="line.221"></a>
<FONT color="green">222</FONT>                                    element<a name="line.222"></a>
<FONT color="green">223</FONT>                            );<a name="line.223"></a>
<FONT color="green">224</FONT>                    }<a name="line.224"></a>
<FONT color="green">225</FONT>            }<a name="line.225"></a>
<FONT color="green">226</FONT>            <a name="line.226"></a>
<FONT color="green">227</FONT>            /**<a name="line.227"></a>
<FONT color="green">228</FONT>             * Returns an xpath like string for the given xml node<a name="line.228"></a>
<FONT color="green">229</FONT>             * <a name="line.229"></a>
<FONT color="green">230</FONT>             * @param node                          the node to convert to a string<a name="line.230"></a>
<FONT color="green">231</FONT>             * @param recurseParents        true if parents should be included<a name="line.231"></a>
<FONT color="green">232</FONT>             * <a name="line.232"></a>
<FONT color="green">233</FONT>             * @return an xpath like string for the given node<a name="line.233"></a>
<FONT color="green">234</FONT>             */<a name="line.234"></a>
<FONT color="green">235</FONT>            public static String getNodePath(Node node, boolean recurseParents) {<a name="line.235"></a>
<FONT color="green">236</FONT>                    if (node instanceof Element) {<a name="line.236"></a>
<FONT color="green">237</FONT>                            return getElementPath((Element)node, recurseParents);<a name="line.237"></a>
<FONT color="green">238</FONT>                    }<a name="line.238"></a>
<FONT color="green">239</FONT>                    final StringBuilder sb = new StringBuilder(node.getName());<a name="line.239"></a>
<FONT color="green">240</FONT>                    if (recurseParents &amp;&amp; node.getParent() != null) {<a name="line.240"></a>
<FONT color="green">241</FONT>                            sb.insert(0, node instanceof Attribute ? '@' : '/');<a name="line.241"></a>
<FONT color="green">242</FONT>                            sb.insert(0, getElementPath(node.getParent(), recurseParents));<a name="line.242"></a>
<FONT color="green">243</FONT>                    }<a name="line.243"></a>
<FONT color="green">244</FONT>                    return sb.toString();<a name="line.244"></a>
<FONT color="green">245</FONT>            }<a name="line.245"></a>
<FONT color="green">246</FONT>            <a name="line.246"></a>
<FONT color="green">247</FONT>            /**<a name="line.247"></a>
<FONT color="green">248</FONT>             * Returns an xpath like string for the given xml element<a name="line.248"></a>
<FONT color="green">249</FONT>             * <a name="line.249"></a>
<FONT color="green">250</FONT>             * @param elem                          the element to convert to a string<a name="line.250"></a>
<FONT color="green">251</FONT>             * @param recurseParents        true if parents should be included<a name="line.251"></a>
<FONT color="green">252</FONT>             * <a name="line.252"></a>
<FONT color="green">253</FONT>             * @return an xpath like string for the given element<a name="line.253"></a>
<FONT color="green">254</FONT>             */<a name="line.254"></a>
<FONT color="green">255</FONT>            public static String getElementPath(Element elem, boolean recurseParents) {<a name="line.255"></a>
<FONT color="green">256</FONT>                    StringBuilder sb = new StringBuilder(elem.getName());<a name="line.256"></a>
<FONT color="green">257</FONT>                    String name = elem.attributeValue(XmlAttribute.name.getXmlName());<a name="line.257"></a>
<FONT color="green">258</FONT>                    if (name != null) {<a name="line.258"></a>
<FONT color="green">259</FONT>                            sb.append("[" + name + "]");<a name="line.259"></a>
<FONT color="green">260</FONT>                    }<a name="line.260"></a>
<FONT color="green">261</FONT>                    if (recurseParents &amp;&amp; !elem.isRootElement() &amp;&amp; elem.getParent() != null) {<a name="line.261"></a>
<FONT color="green">262</FONT>                            sb.insert(0, '/');<a name="line.262"></a>
<FONT color="green">263</FONT>                            sb.insert(0, getElementPath(elem.getParent(), recurseParents));<a name="line.263"></a>
<FONT color="green">264</FONT>                    }<a name="line.264"></a>
<FONT color="green">265</FONT>                    return sb.toString();<a name="line.265"></a>
<FONT color="green">266</FONT>            }<a name="line.266"></a>
<FONT color="green">267</FONT>            <a name="line.267"></a>
<FONT color="green">268</FONT>            //no instances<a name="line.268"></a>
<FONT color="green">269</FONT>            private XmlUtil() {}<a name="line.269"></a>
<FONT color="green">270</FONT>    }<a name="line.270"></a>




























































</PRE>
</BODY>
</HTML>
